@echo off
set WK=\temp
set _WK=/temp
set FD=a:

rem set NAME=atacard
rem set DESTDIR=beos\system\add-ons\kernel\busses\ide
rem set SRCDIR=obj.x86
rem set COPY=1

set DESTDIR=beos\system\add-ons\kernel\busses\scsi
set PATCHSCRIPT=PATCHAIC.BAT

set DELTREE=deltree /y
if "%OS%"=="Windows_NT" set DELTREE=rmdir /s /q

echo This script creates a new installation floppy
echo including a new or updated device driver.
echo.

if not exist %WK%\nul mkdir %WK%

if "%COPY%"=="" goto skip0
	set DRIVER=
	if exist %SRCDIR%\%NAME% set DRIVER=%SRCDIR%\%NAME%
	if exist %NAME% set DRIVER=%NAME%
	if not "%DRIVER%"=="" goto skip0
		echo Device driver %NAME% not found.
		goto end
:skip0

if exist %WK%\*boot.* del %WK%\*boot.*
if exist %WK%\beos\nul %DELTREE% %WK%\beos
if not exist zbeos goto skip1
	copy zbeos %WK%\boot.img
	goto skip2
:skip1
	echo Place R4.5(.x) installation floppy image as zbeos.
	goto end

	echo Mount the original R4.5(.x) installation floppy and press Enter.
	pause > nul
	echo Reading floppy...
	%READFD% %FD% %WK%\boot.img
	if not errorlevel 1 goto skip2
		echo Error reading floppy.
		goto end
:skip2

echo Extracting boot files...
dd if=%WK%\boot.img of=%WK%\newboot.img bs=128k count=1
dd if=%WK%\boot.img of=%WK%\boot.tgz bs=128k skip=1
del %WK%\boot.img
rem the following tar command will end with error
tar xzmf %_WK%/boot.tgz -C %_WK%
attrib -R %WK%\beos\* /s

if "%COPY%"=="" goto skip25
	echo Copying driver file.
	copy %DRIVER% %WK%\%DESTDIR%
	goto skip4
:skip25
	echo Applying patch to driver.
	set DIR=%WK%\%DESTDIR%
	call %PATCHSCRIPT% %1 %2 %3 %4 %5 %6 %7 %8 %9
	if "%errorlevel%"=="1" goto skip3
		echo Patch is successfully applied
		goto skip4
	:skip3
		echo Applying patch failed
		%DELTREE% %WK%\beos
		goto end
:skip4

echo Archiving boot files...
tar czf %_WK%/boot.tgz -C %_WK% beos
%DELTREE% %WK%\beos

echo Creating new floppy image...
copy /b %WK%\newboot.img+%WK%\boot.tgz %WK%\newboot.img
del %WK%\boot.tgz

echo Insert a blank floppy (write-enabled) and press Enter.
pause > nul
echo Writing new floppy...
rawrite2 -n -f %WK%\newboot.img -d %FD%
if not errorlevel 1 goto skip5
	echo Error writing floppy
	goto end
:skip5
del %WK%\newboot.img
echo All done.

:end
set WK=
set _WK=
set DIR=
set DESTDIR=
set PATCHSCRIPT=
set NAME=
set SRCDIR=
set COPY=
